# v8.3 : ajout dism add-driver wvid
# 7v4 25 mars 2021 ajout de quelques fichiers dans system32 ->  revoir !
# 7v3 21 mars 2021 modif nom du vhd et Ajout Linux
# 7v2 11 fev 2021
# 7v1 10 fev 2021

# pb : le formatage ouvre une fentre "explorer" et perturbe l'utilisateur !!!

# Version 7 du 17jan2021 hyperv 


# but : crer un winpe Flat dans un vhd avec ajout SandBox

# note : pour localiser les rpertoires de winSxs  ajouter : rechercher HKLM\COMPONENTS\DisableWerReporting  dans procmon

# j'ai t oblig de recopier tous les rpertoires windows\servicing\packages alors que je filtrais uniquement les noms contenant "hyperV" : bizarre !!!

Write-host -foreground green "Put HyperV and Sandbox in Winpe mode Flat into a new VHD."
Write-host -foreground yellow "Please read the information in the script about creating the BCD file."

#
# modifier version et langue avant utilisation
#
#     les 2 premiers caractres du nom du script fournissent la langue "courte"
#
$version="20H2"
$langue="Fr"
$langueLong=$langueLongUs="$langue-$langue"


$scriptName = $MyInvocation.MyCommand.Name
"scriptName = $scriptName"
if ($scriptName -like "En*") { $langue="En"}

# danger avec En-Gb et En-us
if ($langue -like "En"){ $langueLong="En-Gb"; $langueLongUs="en-Us"}

# param 1 : le rpertoire source ISO
$srcISO="E:\w10-ISO\20H2-pro\apply-$langue\Windows\"

# param 2 : le rpertoire de base pour crer le VHD
$vhdBase = "C:\VHD"

# param 3 : switch cration du VHD
#$createVhd=$true
$createVhd=$false

# modif components
$modifRucheCompopnent=$true
#$modifRucheCompopnent=$false

# param 4 : le rpertoire contenant le fichier Boot.wim du winpe de rfrence
$SrcBoot_wim     = "C:\Users\noelb\Documents\MicroWinpeBuilder-20H2-$langue\build\MEDIA\sources\boot.wim"

$VhdName = "Winpe-20H2-$langue-HyperVSandbox"
$vhdpath = "$vhdBase\$VhdName.vhd"           # $vhdpath = "C:\VHD\Winpe-20H2-Sandbox.vhd"
$label   = $VhdName                          # label    = Winpe-20H2-Sandbox
$vhdsize = 10GB


function pause{
    "pause..."
    $option = [System.Management.Automation.Host.ReadKeyOptions]"IncludeKeyUp";
    $null=$host.UI.RawUI.ReadKey($option)
}

#************************************************************************************************************
#
#    1 - Validate yours datas 
#
#************************************************************************************************************
write-host @"
version              = $version
langue               = $langue
langueLong           = $langueLong
srcISO               = $srcISO
createVhd            = $createVhd
vhdBase              = $vhdBase
VhdName              = $VhdName
driveDst             = $driveDst 
ModifRucheCompopnent = $modifRucheCompopnent
SrcBoot_wim          = $SrcBoot_wim
"@


Write-host -foreground "yellow" "Change the datas in this script by yours settings and comment the first return with '#'"
pause "..."
#return

$startTime = get-date

#contrle de l'existance des rpertoires utiliss
if (! (test-path $srcISO)) { " $srcISO absent !";break}


# cration du psdrive HKCR pour modifier les ruches
$BaseReg             = "hku:" 
if (-not (test-path "$BaseReg") ) {
    $hku = new-psdrive -Name HKU -Root HKEY_USERS -psprovider Registry
}


#test admin
function Test-Admin (){
    # vrifier les droits admin
    $identity = [Security.Principal.WindowsIdentity]::GetCurrent()
    $principal = new-object Security.Principal.WindowsPrincipal $identity
    if ( ! $principal.IsInRole([Security.Principal.WindowsBuiltInRole]::Administrator) )
    {
	    write-host "Il faut lancer powershell en tant qu'administrateur et activer l'excution des scripts !"
	    break
    }
}


Test-Admin

$ErrorActionPreference="stop"
try{Import-Module hyper-v} catch{"Module hyper-v absent";return}

#************************************************************************************************************
#  Warning if VHD attached !
#************************************************************************************************************
$vhd = get-vhd  $vhdpath -ErrorAction SilentlyContinue
if ($vhd.Attached) { 
    write-host -foreground red "$(get-date -Format HH:mm:ss) : VHD attached : confirm and dismount ! "
    write-host -foreground Yellow  "You can use : disMount-VHD -Path $vhdpath"
    return
}


#************************************************************************************************************
#
#    2 - Create a Vhd fixed, mount, initialize MBR, create one partition, formate, active, assign the first free letter
#
#************************************************************************************************************

if ($CreateVhd){
    Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : CreateVhd" 

    #************************************************************************************************************
    #delete VHD file it exists : Warning !
    #************************************************************************************************************
    $ErrorActionPreference = "stop"         # for try/catch
    try{
        if (test-path $vhdpath){"`t`tDelete $vhdpath";remove-item $vhdpath}
    }
    catch{
        Write-Warning -Message "$($_.Exception.Message)"
        break                               # quitte the script
    }

    #***********************************************************************************************************
    # Create a Vhd
    #************************************************************************************************************

    write-host -ForegroundColor "cyan" "When the partition will be created, Explorer opens a windows.`t`nPlease focus on this powershell window"
    "$(get-date -Format HH:mm:ss) : Create VHD..."

    $partitionVhd=New-VHD -Path $vhdpath -Fixed -SizeBytes $vhdsize | Mount-VHD -Passthru | Initialize-Disk -PartitionStyle MBR -Passthru | New-Partition  -UseMaximumSize
    if ($partitionVhd -eq $null) {"Error when creating VHD.";return}

}else{
    Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : ReUse a Vhd" 

    #***********************************************************************************************************
    # Re-use an existing Vhd with only one partition !
    # exclude GPT : to be sure to not format my disk !
    #************************************************************************************************************

    if ( !(test-path $vhdpath)){ write-host -foreground red "$(get-date -Format HH:mm:ss) : Can't find $vhdpath." ; return }
    Mount-VHD $vhdpath -NoDriveLetter
    $vhd = get-vhd  $vhdpath
    $disk = get-disk -Number $vhd.Number
    #if disque gpt then exit
    if ( -not ($disk.PartitionStyle -ne "MBR" -or $disk.PartitionStyle -ne "RAW")){
        write-host -ForegroundColor red "Disque  $($disk.PartitionStyle)!" ; return
    }
    $nbPart=$disk.NumberOfPartitions
    # if more partition than 1 then exit
    if ($nbPart -gt 1){
        write-host -ForegroundColor red "More than one partition !"
        write-host -ForegroundColor Yellow "Please, verify ! `r`n(When you are sure, you can do : clear-disk -Number $($disk.Number)  -RemoveData -RemoveOEM -Confirm:`$false"
        return
    }
    # if 0 partition then clear-disk ....
    if ($nbPart -eq 0){
        write-host -ForegroundColor cyan "No partition !"
        write-host -ForegroundColor cyan "Create a partition (clear-disk, Initialize-Disk, New-Partition) ?"
        pause "clear-disk..."
        clear-disk -Number $disk.Number  -RemoveData -RemoveOEM -Confirm:$false -ErrorAction SilentlyContinue
        $partitionVhd = Initialize-Disk -Number  $vhd.Number -PartitionStyle MBR -Passthru | New-Partition  -UseMaximumSize
    }
    if ($nbPart -eq 1) {
        write-host -ForegroundColor Yellow "One partition"
        $partitionVhd =  get-partition -DiskNumber $vhd.Number
    }

    "Label actuel : $(($partitionVhd | get-volume ).FileSystemLabel)"
    #confirm
    "ok to Format-Volume ?"
    #pause "Format-Volume..."
    "Format-Volume... (hit once 'enter' after an explorer windows is just opened) "
}

#************************************************************************************************************
#   format
#************************************************************************************************************
Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : Format"

$partitionVhd|Format-Volume -FileSystem NTFS -Force -NewFileSystemLabel $label -Confirm:$false
$partitionVhd|Set-Partition -IsActive $true

# I prefer to search again because you could insert a USB drive during the long period of creating VHD
$p=Get-Partition|Select-Object -property DriveLetter | ?{$_.DriveLetter -gt "A"}
$FirstFreeLetter =  [char][int](($p.driveletter| Measure-Object -Maximum).maximum +1)

$partitionVhd|Set-Partition -NewDriveLetter $FirstFreeLetter

#confirm
pause "DISM.exe /Apply-Image..."

#************************************************************************************************************
#    variables for dism and bcdboot
#************************************************************************************************************
$DriveLetter = "$FirstFreeLetter`:"
$driveDst = "$DriveLetter\"

#************************************************************************************************************
#
#    3 - apply boot.wim into VHD
#
#************************************************************************************************************
Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : Apply boot.wim into the VHD $driveDst"

DISM.exe /Apply-Image /Index:1 /ImageFile:$SrcBoot_wim  /ApplyDir:$driveDst


#************************************************************************************************************
#
#    4 - create BCD with bcdboot
#
#************************************************************************************************************
<#
It is possible to use an VHD in two ways:
- In a VM (I use only hyperV)
    The VHD file is the VM's hard drive
    The BCD file to be created is located inside the VHD
- In a physic machine
    Depending on your needs and tests, the VHD file is contained:
    - either in the machine's hard drive
    - either in an extended USB hard drive
    The BCD file to be modified is contained in the "physical" start-up hard drive
    This script does not deal with this case: it's up to you to make the change
#>

Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : Create BCD for a VM"

bcdboot.exe  $DriveLetter\windows /s $DriveLetter /f ALL

# you can customise the BCD with bcdedit : 
# bootlog = create the list of drivers loaded at boot time, in x:\windows\ntboot.log
bcdedit.exe /store $driveDst\boot\bcd /set `{default`} bootlog YES

#************************************************************************************************************
#
#    5 - Verify in BCD if winpe = Yes
#
#************************************************************************************************************
$w=bcdedit.exe /store $driveDst\boot\bcd
$w
if ( -not ([bool]($w -like "*winpe*"))){ Write-Host -ForegroundColor red "Verify BCD because it seems 'winpe' is absent"}

#************************************************************************************************************
#
#    6 - 
#
#************************************************************************************************************


# un rep de travail pour modifier les ruches
$destSave = "$driveDst\optionalFeatures"
if ( !(test-path $destSave\System32\config\ )){
    $null=md $destSave\System32\config\
}

$destFinale = "$driveDst\Windows\"

# notes sur les pb de ce script :
# les repertoires suivants sont protgs en criture :
#	\windows\winsxs 
#	\windows\Servicing

# note : absence du service wuauserv: utile pour une mise  jour automatique mais dangereuse !
#		cas non test !!!

# PB : pour telnet, je ne comprends comment devrait arriver le .mui : actuellement je le recopie manuellement  !

#
# liste des cls et fichiers utiles pour Sanbox dans optionalfeatures.exe
#
# - Winsxs de l'iso contient les fichiers compresss
#
# - cls absentes avec optionalfeatures.exe  et ajout de Sandbox :
#           winpe : \DerivedData\VersionedIndex\10.0.19041.1
#           ISO   : \DerivedData\VersionedIndex\10.0.19041.504



function set-ownerForFile ($cible, $Inherit=("ContainerInherit", "ObjectInherit")){
    try{
        if(test-path $cible){
            #$objUser = New-Object System.Security.Principal.NTAccount("wingroup\kenmyer") 
            #$me = [System.Security.Principal.NTAccount]$NewOwner # "BUILTIN\Administrateurs" ou un autre
            $me = [System.Security.Principal.NTAccount]"BUILTIN\Administrateurs"
            $acl = Get-ACL -path  $cible
            # pour devenir propriÃ©taire
            $acl.SetOwner($me)
            set-acl -path $cible -aclObject $acl

            # crÃ©ation d'une acl
            $colRights = [System.Security.AccessControl.FileSystemRights]"FullControl" 
            #$allInherit = [System.Security.AccessControl.InheritanceFlags]"ContainerInherit", "ObjectInherit"
            $allInherit = [System.Security.AccessControl.InheritanceFlags]$Inherit
            $allPropagation = [System.Security.AccessControl.PropagationFlags]"None"
            $objType =[System.Security.AccessControl.AccessControlType]::Allow 
            $objACE = New-Object System.Security.AccessControl.FileSystemAccessRule `
                ($me, $colRights, $allInherit, $allPropagation, $objType) 
            # pour avoir fullControl
            $acl = Get-ACL -path  $cible
            $acl.AddAccessRule($objACE) 
            Set-ACL $cible $acl
        }else{
            write-host -foreground red ">>>>>>>>> Anomalie 'Rpertoire ou fichier absent' : $cible"
        }
    }
    catch{
        write-host -foreground red "catch set-ownerForFile"
        throw "ERREUR set-ownerForFile"
    }
}

$phase=1

#
Write-host -foreground Green "$(get-date -Format HH:mm:ss) : Ajout Hyperv-Sandbox"
#


Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Utilisation de la ruche COMPONENTS de l'ISO"
#       on injecte les donnes de winpe dans la ruche COMPONENTS de l'ISO
#       puis on la recopie dans winpe
# note : il ne s'agit pas d'un "rel merge" car la cl racine contient une information de version

# cls à traiter :
#	\COMPONENTS\DerivedData\Components
#	\COMPONENTS\DerivedData\VersionedIndex
if ($modifRucheCompopnent){

    # data pour "VersionedIndex
    $cles=@"
    amd64_microsoft-windows-http-api_31bf3856ad364e35_none_734750adda2e6865\v!10.0.19041.1
    amd64_microsoft-windows-d..ing-management-core_31bf3856ad364e35_none_66ad778b3c3e0bcc\v!10.0.19041.1
    amd64_microsoft-windows-d..ervicing-management_31bf3856ad364e35_none_2277c9a523073bca\v!10.0.19041.1
    amd64_microsoft-windows-d..cing-management-api_31bf3856ad364e35_none_dc6483268bbc9935\v!10.0.19041.1
    amd64_microsoft-windows-eventlog-api_31bf3856ad364e35_none_79aa61ad522e9771\v!10.0.19041.1
    amd64_microsoft-windows-d..gement-winproviders_31bf3856ad364e35_none_f21e73acf5c7442d\v!10.0.19041.1
    amd64_microsoft-windows-ntlanman_31bf3856ad364e35_none_77b872e70b5deec9\v!10.0.19041.1
    amd64_microsoft-windows-smb20-minirdr_31bf3856ad364e35_none_5038ca368704679a\v!10.0.19041.1
    amd64_microsoft-windows-rdbss_31bf3856ad364e35_none_b8a40c5fc464026c\v!10.0.19041.1
    amd64_microsoft-windows-smbminirdr_31bf3856ad364e35_none_caf94479a9c1c995\v!10.0.19041.1
    amd64_microsoft-windows-c..s-client-deployment_31bf3856ad364e35_none_a2ba222d2da71fb2\v!10.0.19041.1
    amd64_microsoft-windows-b..tp-minio-deployment_31bf3856ad364e35_none_18212cbc6ca21abc\v!10.0.19041.1
"@

    # on sauvegarde la ruche COMPONENTS de winpe dans son rep
    rename-item $destFinale\System32\config\COMPONENTS $destFinale\System32\config\COMPONENTS.winpe
    # on recopie la ruche COMPONENTS de winpe dans le rep de sauvegarde
    copy $destFinale\System32\config\COMPONENTS.winpe  $destSave\System32\config\
    # on recopie la ruche COMPONENTS de l'iso dans le rep de sauvegarde 
    copy $srcISO\System32\config\COMPONENTS $destSave\System32\config\COMPONENTS.todo

    $SrcClesWinpe = "hku\COMPONENTSWinpe"
    $destCles     = "hku\COMPONENTSTodo"

    # on charge les ruches
    reg load $destCles $destSave\System32\config\COMPONENTS.todo
    reg load $SrcClesWinpe $destSave\System32\config\COMPONENTS.winpe

    #copie  Components
    Write-host -foreground yellow "$(get-date -Format HH:mm:ss) `t`tCopie  de ...\Components"

    $regSrc="$SrcClesWinpe\DerivedData\Components"
    $regDst="$destCles\DerivedData\Components"
    reg copy $regsrc $regDst /s /f

    # lire la version dans l'iso et dans winpe
    $versionWinpe  = (Get-ItemProperty -Path  "$($SrcClesWinpe.replace("hku\","hku:\"))\ServicingStackVersions" -Name LastWCPVersionToAccessStore).LastWCPVersionToAccessStore
    $versionIso = (Get-ItemProperty -Path  "$($destCles.replace("hku\","hku:\"))\ServicingStackVersions" -Name LastWCPVersionToAccessStore).LastWCPVersionToAccessStore

    # copie  ComponentFamilies  
    Write-host -foreground yellow "$(get-date -Format HH:mm:ss) `t`tCopie  de ...\ComponentFamilies"
    $regSrcCopy="$SrcClesWinpe\DerivedData\VersionedIndex\$versionWinpe\ComponentFamilies\"
    $regDstCopy="$destCles\DerivedData\VersionedIndex\$versionIso\ComponentFamilies\"

    foreach ($cle in $($cles -Split "`r`n")) {
        $cle=$cle.trim()
        #write-host   "$regSrcCopy$cle -> $regDstCopy$cle"
	    reg.exe copy "$regSrcCopy$cle" "$regDstCopy$cle" /S
    }

    #pause
    #"$(get-date -Format HH:mm:ss) `t`tunload"

    reg unload $destCles
    reg unload $SrcClesWinpe

    # on recopie la ruche modifie dans le rep config de winpe
    copy $destSave\System32\config\COMPONENTS.todo  $destFinale\System32\config\COMPONENTS

    rename-item $destSave\System32\config\COMPONENTS.todo $destSave\System32\config\COMPONENTS.new
}

Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Ajout des fichiers utiles pour OptionalFeatures.exe"

$Files=@"
OptionalFeatures.exe
\$langueLong\OptionalFeatures.exe.mui
sxsstore.dll
sxproxy.dll
wuaueng.dll
ProductEnumerator.dll
wuapi.dll
\$langueLong\wuapi.dll.mui
wups.dll
"@

foreach ($file in $($Files -Split "`r`n")) {
	copy $srcISO\System32\$file $destFinale\System32\$file
}


Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - ajout des fichiers HyperV qui ne sont pas apports par Dism"

resolve-path $srcISO\System32\HV* | %{
    $name = $(($_ -split ("\\"))[-1])
    if (! (test-path $destFinale\System32\$name)){
        copy $_ $destFinale\System32\ -ea Continue
    }
}
# si en-gb alors les hv...mui vont dans en-us 
resolve-path $srcISO\System32\$langueLongUs\HV* | %{
    $name = $(($_ -split ("\\"))[-1])
    if (! (test-path $destFinale\System32\$langueLongUs$name)){
        copy $_ $destFinale\System32\$langueLongUs\ -ea Continue
    }
}


# si en-gb alors les hv...mui vont dans en-us 
$f="drivers\hvservice.sys","drivers\wcifs.sys", "drivers\synth3DVsc.sys", "drivers\$langueLongUs\synth3DVsc.sys.mui",
    "drivers\winhvr.sys", "drivers\vid.sys",
    "computeNetwork.dll","$langueLongUs\computenetwork.dll.mui", "computecore.dll", "computelibeventlog.dll", 
    "$langueLongUs\computelibeventlog.dll.mui", "wcimage.dll", "computestorage.dll", "vid.dll", "$langueLongUs\vid.dll.mui"
   
$f|%{
    if (! (test-path $destFinale\System32\$_)){
        copy $srcISO\System32\$_ $destFinale\System32\$_ -ea Continue
    }
}


Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Ajout de winsxs\...\tiworker  (amd64 et x86)"
set-ownerForFile $destFinale\winsxs

#\winsxs\amd64_microsoft-windows-servicingstack_31bf3856ad364e35_10.0.19041.504_none_e781e76525fb2269\
$dirTi="amd64_microsoft-windows-servicingstack_31bf3856ad364e35_10.0.19041.504_none_e781e76525fb2269\"
$DebNom = ($dirTi -Split ".19041.")[0]
$dirNames = resolve-path $srcIso\WinSxS\$DebNom*
foreach ($r in $dirNames){
    if( ! (test-path $destFinale\WinSxS\$r ) ){
        "$r"  >> "$destSave\copieWinSxs.txt"
	    copy-item -r $r\ $destFinale\WinSxS\ -ea Silentlycontinue
    }else{
        "Error : $r"
    }
}

#\winsxs\x86_microsoft-windows-servicingstack_31bf3856ad364e35_10.0.19041.504_none_8b634be16d9db133\ 
$dirTi="x86_microsoft-windows-servicingstack_31bf3856ad364e35_10.0.19041.504_none_8b634be16d9db133\"
$DebNom = ($dirTi -Split ".19041.")[0]
$dirNames = resolve-path $srcIso\WinSxS\$DebNom*
foreach ($r in $dirNames){
    if( ! (test-path $destFinale\WinSxS\$r ) ){
        "$r"  >> "$destSave\copieWinSxs.txt"
	    copy-item -r $r\ $destFinale\WinSxS\ -ea Silentlycontinue
    }else{
        "Error : $r"
    }
}

#quid des fichiers .manifest et .cat pour winsxs???

Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Merge des 2 rpertoires ...\winsxs\manifests, iso et winpe (c'est long car +17000 fichiers...)"
# 17174 fichiers pour l'ISO
#  5554 fichiers pour mon winpe

copy -r $srcISO\winsxs\Manifests\* $destFinale\winsxs\Manifests

Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - rpertoire ...\WinSxS\Catalogs : ????" 
#	???


Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Mise  jour du rpertoire ...\Windows\system32\CatRoot\{F750E6C3-38EE-11D1-85E5-00C04FC295EE}" 
# pour l'instant j'ai aussi identifi le .cat pour Vid.sys : HyperV-VID-Package~31bf3856ad364e35~amd64~~10.0.19041.546.cat
# et aussi celui de synth3dVcp.sys
#Microsoft-Windows-RemoteFX-HyperV-Integration-Package~31bf3856ad364e35~amd64~~10.0.19041.84.cat
#copy-item "$catRootSrc\Microsoft-Windows-RemoteFX-HyperV-Integration-Package~31bf3856ad364e35~amd64~~10.0.19041.84.cat" $catrootFinale

# mais je copie tous les fichiers .cat dont le nom contient "hyperv" : 376 pour 20h2

$catRootSrc   = "$srcISO\system32\CatRoot\{F750E6C3-38EE-11D1-85E5-00C04FC295EE}"
$catrootFinale =  "$destFinale\system32\CatRoot\{F750E6C3-38EE-11D1-85E5-00C04FC295EE}"
$cats = gci  $catRootSrc  -Filter "*hyperv*"
$cats | foreach {
    if ( !(test-path $catrootFinale\$($_.Name) )){
        copy-item $_.fullName $catrootFinale 
    }
}


Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - CBS:  copie de \Windows\Containers"
copy-item -r $srcISO\Containers $destFinale\Containers

Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Modification de la ruche SYSTEM" 

# on copie la ruche system dans le rep de sauvegarde 
copy $destFinale\System32\config\system $destSave\System32\config\system.todo
# on sauvegarde la ruche system dans son rep
move $destFinale\System32\config\system $destFinale\System32\config\system.winpe
# on recopie la ruche system depuis l'iso
copy  $srcISO\System32\config\system $destSave\System32\config\system.fromIso

#
# modif system
#
reg load hku\systemTodo $destSave\System32\config\system.todo
reg load hku\systemfromIso $destSave\System32\config\system.fromIso

Write-host -foreground Yellow "$(get-date -Format HH:mm:ss) : `t`tajout de 'HKLM\SYSTEM\Setup\Service Reporting API\Baselines'" 
$regsrc="hku\systemfromIso\Setup\Service Reporting API\Baselines"
$regDst="hku\systemTodo\Setup\Service Reporting API\Baselines"
reg copy $regsrc $regDst /s /f

#**************************************************************************************************
# j'ai fait le test en retirant l'ajout de ces drivers pour vrifier qu'ils sont/seront ajouts par dism
# rsultat du test : ces pilotes ne sont pas ajouts par dism /enable-feature  hperv
#                    ils sont prsents dans l'ISO !
#**************************************************************************************************
#ajout 12jan : 2 drivers et 1 service
Write-host  -foreground Yellow "$(get-date -Format HH:mm:ss) `t`tajout dans 'HKLM\SYSTEM\ControlSet001\Services\'" 
$regsrc="hku\systemfromIso\ControlSet001\Services"
$regDst="hku\systemTodo\ControlSet001\Services"
reg copy  "$regsrc\hvservice" "$regDst\hvservice" /s /f
reg copy  "$regsrc\HvHost" "$regDst\HvHost" /s /f
reg copy  "$regsrc\wcifs" "$regDst\wcifs" /s /f

#ajout 12jan :vid.sys et ne pas oublier les fichiers
reg copy  "$regsrc\vid" "$regDst\vid" /s /f

# ajout 16jan
reg copy  "$regsrc\synth3DVsc" "$regDst\synth3DVsc" /s /f 

# on copie \ControlSet001\Control\Version\Kernel
$regsrc="hku\systemfromIso\ControlSet001\Control\Version"
$regDst="hku\systemTodo\ControlSet001\Control\Version"
reg copy  "$regsrc" "$regDst" /s /f

#pause

#"$(get-date -Format HH:mm:ss) `t`tunload"
reg unload hku\systemTodo
reg unload hku\systemfromIso

# on recopie la ruche modifiÃ©e dans son rep
copy $destSave\System32\config\system.todo  $destFinale\System32\config\system

rename-item $destSave\System32\config\system.todo $destSave\System32\config\system.new

Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) $phase$($phase++) - CBS: copie de '...\servicing\FodMetadata et ...\servicing\InboxFodMetadataCache'"

set-ownerForFile $destFinale\Servicing\
copy-item -r $srcISO\servicing\FodMetadata\* $destFinale\Servicing\FodMetadata
copy-item -r $srcISO\servicing\FodMetadata\metadata $destFinale\Servicing\FodMetadata
copy-item -r $srcISO\servicing\InboxFodMetadataCache\* $destFinale\Servicing\InboxFodMetadataCache
copy-item -r $srcISO\servicing\InboxFodMetadataCache\metadata $destFinale\Servicing\InboxFodMetadataCache

##### investigation  reprendre ici car faut-il tout craser ou seulement faire un "merge" ?
Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) $phase$($phase++) - CBS: copie de \windows\Servicing\Packages\"
# 3400 rep !
set-ownerForFile $destFinale\Servicing\Packages

$PackagesRootSrc   = "$srcISO\Servicing\Packages\"
$PackagesrootFinale =  "$destFinale\Servicing\Packages\"

#Copy-Item "$PackagesRootSrc\Microsoft-Windows-Foundat*" $PackagesrootFinale

#$Packages = gci  $PackagesRootSrc  -Filter "*hyperv*"
$Packages = gci  $PackagesRootSrc 
$Packages | foreach {
    if ( !(test-path $PackagesrootFinale\$($_.Name) )){
        copy-item $_.fullName $PackagesrootFinale
        #"$PackagesrootFinale\$($_.Name)" 
    }else{
        "? $($_.Name)"
    }
}


Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) $phase$($phase++) - Test avec telnet : WinSxS\...\telnet.exe est compress !!!"
# ajout dans winsxs des objets pour telnet
# ...\WinSxS\amd64_microsoft-windows-telnet-client_31bf3856ad364e35_10.0.19041.1_none_6e229ee8c467f101\
$r = "amd64_microsoft-windows-telnet-client_31bf3856ad364e35_10.0.19041.1_none_6e229ee8c467f101\"
$dest3="$destFinale\winsxs\$r"
copy-item -r $srcISO\winsxs\$r $dest3

Write-host -foreground Yellow  "$(get-date -Format HH:mm:ss) `t`tRecopie de telnet.exe.mui"
copy $srcISO\System32\$langueLongUs\telnet.exe.mui $destFinale\System32\$langueLongUs\telnet.exe.mui


Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) $phase$($phase++) - copie dans winsxs pour SandBox"

# fichiers Fr

$Files=@"
amd64_microsoft-hyper-v-pvhd-parser_31bf3856ad364e35_10.0.19041.1_none_3f6b6ada79aa7a69
amd64_microsoft-hyper-v-pvhd-parser.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_af4e722a446a8f4b
amd64_microsoft-hyper-v-vstack-vmwp_31bf3856ad364e35_10.0.19041.572_none_1315645abeb3e15f
amd64_microsoft-hyper-v-vstack-vmwp.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_d9215e46435b05ba
amd64_hyperv-vmserial_31bf3856ad364e35_10.0.19041.153_none_77ff19f03034f284
amd64_hyperv-vmserial.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_e02fed86ac6e6318
amd64_hyperv-sbresources_31bf3856ad364e35_10.0.19041.1_none_2d8977225e440f3f
amd64_hyperv-sbresources.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_481e74f0a64e1d75
amd64_hyperv-vpci-rootporterr_31bf3856ad364e35_10.0.19041.1_none_1bb8e159224f066a
amd64_hyperv-vpci-rootporterr.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_a3e15e4ba762f346
amd64_dual_wvpcivsp.inf_31bf3856ad364e35_10.0.19041.207_none_e90623c3f0674d4b
amd64_wvpcivsp.inf.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_2c7711b096f2710d
amd64_hyperv-compute-eventlog_31bf3856ad364e35_10.0.19041.1_none_95c78c06618b49c3
amd64_hyperv-compute-eventlog.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_c51c9502197b3091
amd64_hyperv-worker-events.resources_31bf3856ad364e35_10.0.19041.488_fr-fr_38b7aeb909570d00
amd64_hyperv-worker-events_31bf3856ad364e35_10.0.19041.488_none_fde4c1454c01ca46
amd64_microsoft-windows-container-manager_31bf3856ad364e35_10.0.19041.546_none_70d945063c76aab6
amd64_microsoft-windows-c..r-manager.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_f03f03b8f63e557e
amd64_hyperv-vmchipset_31bf3856ad364e35_10.0.19041.546_none_b3371931eb77a45c
amd64_hyperv-vmchipset.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_85443bc0017279a4
amd64_hyperv-vmpmem_31bf3856ad364e35_10.0.19041.153_none_c0bcb7a7f2bd47af
amd64_hyperv-vmpmem.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_1f2f0b87f7d8c9b5
amd64_hyperv-vmiccore_31bf3856ad364e35_10.0.19041.546_none_b2ba2c78d1679fa7
amd64_hyperv-vmiccore.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_2af4f725b947d5f3
amd64_hyperv-vmbusvdev_31bf3856ad364e35_10.0.19041.546_none_ac054d19126a92e5
amd64_hyperv-vmbusvdev.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_4fdf2a590919178b
amd64_hyperv-vmsynthnic_31bf3856ad364e35_10.0.19041.546_none_8d30ab5c8b770ecc
amd64_hyperv-vmsynthnic.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_a599b36277ace06a
amd64_dual_wvkrnlintvsp.inf_31bf3856ad364e35_10.0.19041.1_none_bfb94f73cdbe8665
amd64_wvkrnlintvsp.inf.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_0b7109dfef2ecb85
amd64_hyperv-vmcrashdump_31bf3856ad364e35_10.0.19041.546_none_f0756979f2cccc49
amd64_hyperv-vmcrashdump.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_75bd8743b20f984b
amd64_dual_wvmbusr.inf_31bf3856ad364e35_10.0.19041.546_none_d0eb3d205ecd5e01
amd64_wvmbusr.inf.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_b2b5e57e169f358d
amd64_microsoft-hns-diagnosticstool_31bf3856ad364e35_10.0.19041.423_none_841c30f68571c385
amd64_microsoft-hns-diagnosticstool.resources_31bf3856ad364e35_10.0.19041.1_en-us_73077e9bbbdaf816
amd64_dual_wvms_vspp.inf_31bf3856ad364e35_10.0.19041.1_none_30a7e8c64e41461a
amd64_wvms_vspp.inf.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_48757ed9727e1e44
amd64_disposableclientvm.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_61251b5a162d4bc2
amd64_microsoft-windows-c..-disposableclientvm_31bf3856ad364e35_10.0.19041.488_none_c36691fe3aaefd93
amd64_hyperv-compute-host-service_31bf3856ad364e35_10.0.19041.546_none_d5a1b2c30a82434d
amd64_hyperv-compute-host-service.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_bba8d1a03d9a0cd9
amd64_hyperv-compute-guestcomputeservice_31bf3856ad364e35_10.0.19041.488_none_6b54fed271d58d34
amd64_hyperv-compute-gues..teservice.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_e799932c1d776709
amd64_hyperv-vmdynmem_31bf3856ad364e35_10.0.19041.546_none_db1c1c9c6473df7a
amd64_hyperv-vmdynmem.resources_31bf3856ad364e35_10.0.19041.1_en-us_3b4d471b734cce4b
amd64_dual_wvms_vsft.inf_31bf3856ad364e35_10.0.19041.1_none_226e9b9b5f8a0108
amd64_wvms_vsft.inf.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_1e2d9d399fddd526
amd64_microsoft-windows-l2bridge-filter-driver_31bf3856ad364e35_10.0.19041.1_none_ca887a58de695dca
amd64_microsoft-windows-l..er-driver.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_d7baa7d4e216afbe
amd64_microsoft-windows-hns-wfp-driver_31bf3856ad364e35_10.0.19041.1_none_613585ecd8686899
amd64_microsoft-windows-h..fp-driver.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_dfae36e51c2243bd
amd64_dual_wvms_mp_windows.inf_31bf3856ad364e35_10.0.19041.1_none_b3c08f49461b9e34
amd64_wvms_mp_windows.inf.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_b39386baa5ca3dde
amd64_dual_wvms_pp.inf_31bf3856ad364e35_10.0.19041.1_none_d525bfd1421c864f
amd64_wvms_pp.inf.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_d24993a796530ff5
amd64_microsoft-windows-n..irtualization-agent_31bf3856ad364e35_10.0.19041.1_none_fe31ccb74b39a5f9
amd64_microsoft-windows-n..ion-agent.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_a922bc3b20ea38f9
amd64_microsoft-hyper-v-vstack-vsmb_31bf3856ad364e35_10.0.19041.572_none_0ce6e562c2ab39bd
amd64_microsoft-hyper-v-vstack-vsmb.resources_31bf3856ad364e35_10.0.19041.423_fr-fr_93cd1ea1f15eb48e
amd64_microsoft-windows-host-network-service_31bf3856ad364e35_10.0.19041.572_none_d8b94b80bf14f1c1
amd64_microsoft-windows-h..k-service.resources_31bf3856ad364e35_10.0.19041.423_fr-fr_ae73e4d390c4268e
amd64_microsoft-windows-guest-network-service_31bf3856ad364e35_10.0.19041.153_none_4b80d18369bb4eca
amd64_microsoft-windows-g..k-service.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_d5b28d127cd6363e
amd64_hyperv-compute-containerdiagnosticstool_31bf3856ad364e35_10.0.19041.1_none_3d521dedd6c76700
amd64_hyperv-compute-cont..sticstool.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_bc878392a6f92ccc
amd64_hyperv-gpupvdev_31bf3856ad364e35_10.0.19041.1_none_edcbd395194f25be
amd64_hyperv-gpupvdev.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_098bc1a5243bfbc8
amd64_hyperv-vmuidevices_31bf3856ad364e35_10.0.19041.546_none_5b984867215cc297
amd64_hyperv-vmuidevices.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_afd05653db171037
amd64_hyperv-vmsynthstor_31bf3856ad364e35_10.0.19041.546_none_932575e5c79468ec
amd64_hyperv-vmsynthstor.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_6402e881a991e104
amd64_hyperv-compute-cont..utionservice-shared_31bf3856ad364e35_10.0.19041.1_none_0bc0f3d4cd7dc8fd
amd64_hyperv-compute-cont..ce-shared.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_c3d467c525734eb3
amd64_microsoft-windows-h..-network-management_31bf3856ad364e35_10.0.19041.1_none_7a53549f2797bc70
amd64_microsoft-windows-h..anagement.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_7b8840f2b115e0e0
amd64_microsoft-hyper-v-d..s-vmswitch-netsetup_31bf3856ad364e35_10.0.19041.572_none_623ca1e0ba378b0a
amd64_microsoft-hyper-v-d..-netsetup.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_cc1d98780d42cae5
amd64_hyperv-compute-proxy_31bf3856ad364e35_10.0.19041.1_none_a90d1c1a25a82b97
amd64_hyperv-computelib-legacy_31bf3856ad364e35_10.0.19041.546_none_9098320b8966ab2d
amd64_hyperv-vmkernelintvdev_31bf3856ad364e35_10.0.19041.546_none_dfdb67fb9101aec3
amd64_hyperv-vmflexiovdev_31bf3856ad364e35_10.0.19041.1_none_7031a37c6c34fbf0
amd64_hyperv-networking-switch-interface_31bf3856ad364e35_10.0.19041.546_none_c4439b9a4d5ab4b8
amd64_hyperv-vpcibus_31bf3856ad364e35_10.0.19041.488_none_6920a6bb7b8ab8c8
amd64_hyperv-vp9fs_31bf3856ad364e35_10.0.19041.153_none_dc5d06f37302e699
amd64_hyperv-worker-control_31bf3856ad364e35_10.0.19041.546_none_ee5483161f427e69
amd64_hyperv-hvsocket-control_31bf3856ad364e35_10.0.19041.1_none_cb1d2b492a944f5e
amd64_hyperv-virtio_31bf3856ad364e35_10.0.19041.1_none_0d1d5bd368748c54
amd64_microsoft-hyper-v-vhd-parser_31bf3856ad364e35_10.0.19041.1_none_34b87765e20dcc15
amd64_microsoft-hyper-v-passthru-parser_31bf3856ad364e35_10.0.19041.1_none_d7dfb451bd621127
amd64_microsoft-hyper-v-kmclr_31bf3856ad364e35_10.0.19041.1_none_884ef285596dd594
amd64_microsoft-onecore-utilityvm-setupagent_31bf3856ad364e35_10.0.19041.1_none_cf994a1a65720fd5
amd64_microsoft-windows-a..perv-computestorage_31bf3856ad364e35_10.0.19041.1_none_8e72af404f9bccc9
amd64_microsoft-windows-a..perv-computenetwork_31bf3856ad364e35_10.0.19041.1_none_13e8e5960c73b914
amd64_microsoft-windows-a..evicevirtualization_31bf3856ad364e35_10.0.19041.1_none_888692f10660b270
amd64_microsoft-windows-a..yperv-computelegacy_31bf3856ad364e35_10.0.19041.1_none_397b846c65d702cf
amd64_microsoft-windows-a..-hyperv-computecore_31bf3856ad364e35_10.0.19041.1_none_d90d490faf321903
amd64_microsoft-windows-t..aboration-rdp4vsapi_31bf3856ad364e35_10.0.19041.84_none_2556d82478682a06
amd64_microsoft-windows-s..y-spp-virtualdevice_31bf3856ad364e35_10.0.19041.546_none_97689a654d910d87
amd64_microsoft-windows-hyper-v-vfpext_31bf3856ad364e35_10.0.19041.488_none_de859b294aaf30f7
amd64_microsoft-windows-d..ervicing-management_31bf3856ad364e35_10.0.19041.572_none_3c7e792c6c97a434
amd64_microsoft-windows-d..cing-management-api_31bf3856ad364e35_10.0.19041.572_none_8496ae75be375b71
amd64_microsoft-windows-d..gement-winproviders_31bf3856ad364e35_10.0.19041.572_none_95228fac03d758b9
amd64_microsoft-windows-d..ing-management-core_31bf3856ad364e35_10.0.19041.572_none_0908fc1989aa5422
amd64_microsoft-windows-c..rs-serverdefinition_31bf3856ad364e35_10.0.19041.292_none_f0c228b323fd306e
amd64_microsoft-windows-smbminirdr_31bf3856ad364e35_10.0.19041.488_none_5d617333b00b5ee5
amd64_microsoft-windows-smb20-minirdr_31bf3856ad364e35_10.0.19041.488_none_68aafb99e8b3d0b8
amd64_microsoft-windows-rdbss_31bf3856ad364e35_10.0.19041.488_none_37a4ddcac0575f56
amd64_microsoft-windows-http-api_31bf3856ad364e35_10.0.19041.546_none_d3a583fffc1b244a
amd64_microsoft-windows-ntlanman_31bf3856ad364e35_10.0.19041.546_none_0e0a5cc5416f6ac6
amd64_microsoft-windows-eventlog-api_31bf3856ad364e35_10.0.19041.546_none_8a2a491cc4197cde
amd64_gpuvirtualizationumed_31bf3856ad364e35_10.0.19041.1_none_314bcd30a97ac56c
amd64_dual_wstorvsp.inf_31bf3856ad364e35_10.0.19041.572_none_9ecba15f1b37beba
amd64_wstorvsp.inf.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_21cfbc4b68e71483
amd64_dual_wvkrnlintvsc.inf_31bf3856ad364e35_10.0.19041.1_none_a9d16fc0aa10e172
amd64_wvkrnlintvsc.inf.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_9b21efc9d44314b0
amd64_hyperv-proxy-onecore_31bf3856ad364e35_10.0.19041.546_none_496965e05bb422ed
"@


# la liste est correcte pour la langue Fr
# modif pour avoir la mme liste mais avec une autre langue : en esprant que cela soit une bonne ide !
# il s'agit uniquement de copie de rpertoires dans winSxs
# si langue = fr alors voir di-dessus
# sinon
#  pour chaque nom 
#    split du nom : on ne garde que le dbut du nom
#    $dirNames = resolve-path DebNom*
#    pour chaque dirName
#     si le rpertoire de dest existe, alors erreur
#     sinon copie
if ($langueLong -like "Fr-Fr"){
    foreach ($file in $($Files -Split "`r`n")) {
        if( ! (test-path $destFinale\WinSxS\$file ) ){
	        copy-item -r $srcIso\WinSxS\$file\ $destFinale\WinSxS\ -ea Silentlycontinue
        }else{
            "Error : $destFinale\WinSxS\$file"
        }
    }
}else{
    foreach ($file in $($Files -Split "`r`n")) {
        $DebNom = ($file -Split ".19041.")[0]
        $dirNames = resolve-path $srcIso\WinSxS\$DebNom*
        foreach ($r in $dirNames){
            if( ! (test-path $destFinale\WinSxS\$(($r -split "\\")[-1])) ){
                $r  >> "$destSave\copieWinSxs.txt"
	            copy-item -r $r\ $destFinale\WinSxS\ -ea Silentlycontinue
            }else{
                "Error : $r"
            }
        }
    }
}
      


Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) $phase$($phase++) - Copie dans winsxs pour hyperv"

# fichiers En-Gb

$fileHyperV=@"
amd64_dual_wvid.inf_31bf3856ad364e35_10.0.19041.423_none_d036443f600dab4b
amd64_wvid.inf.resources_31bf3856ad364e35_10.0.19041.1_en-us_c52a169663dd50ae
wow64_hyperv-ux-featurestaging_31bf3856ad364e35_10.0.19041.1_none_de5a636f552d340b
msil_microsoft.virtualiz..lient.6.3.vmbrowser_31bf3856ad364e35_10.0.19041.1_none_d2dcf5893073536b
amd64_hyperv-commandline-tool_31bf3856ad364e35_10.0.19041.1_none_e2f75fda217d5015
amd64_vmconnect6.2.resources_31bf3856ad364e35_10.0.19041.1_en-us_3a975af1678a7fb6
amd64_hyperv-commandline-tool.resources_31bf3856ad364e35_10.0.19041.1_en-us_a6356880f25940ae
msil_microsoft.virtualiz..nt.common.resources_31bf3856ad364e35_10.0.19041.1_en-us_42467bb5b54aff5d
msil_microsoft.virtualiz..lient.6.2.resources_31bf3856ad364e35_10.0.19041.1_en-us_14c507131182c956
amd64_microsoft-hyper-v-ram-parser.resources_31bf3856ad364e35_10.0.19041.1_en-us_50c23e4c771f203a
amd64_microsoft.virtualiz..ent.rdpclientaxhost_31bf3856ad364e35_10.0.19041.631_none_853fd445d46481d1
amd64_hyperv-vpcivdev_31bf3856ad364e35_10.0.19041.1_none_627d42b0cf6b54a2
amd64_microsoft.windows.h..gnostics.powershell_31bf3856ad364e35_10.0.19041.1_none_28cc79912e3b379a
amd64_microsoft-hyper-v-ram-parser_31bf3856ad364e35_10.0.19041.1_none_a7bb53746630ebd3
msil_microsoft.virtualiz..vmbrowser.resources_31bf3856ad364e35_10.0.19041.1_en-us_12bd4ac9b04c8731
amd64_microsoft-hyper-v-v..edstorage.resources_31bf3856ad364e35_10.0.19041.1_en-us_8e6d1518accc0bf5
amd64_microsoft-hyper-v-vstack-hypervcluster_31bf3856ad364e35_10.0.19041.1_none_a2ace16370124ff4
amd64_microsoft.virtualiz..nt.rdpclientinterop_31bf3856ad364e35_10.0.19041.1_none_21bb9db51cc6f1ec
msil_microsoft.virtualiz..client.6.2.settings_31bf3856ad364e35_10.0.19041.1_none_ada5c8757a0d2f2a
amd64_microsoft-hostguard..t-service.resources_31bf3856ad364e35_10.0.19041.1_en-us_6bb542f445b28a5c
amd64_microsoft.hostguard..ent.service.interop_31bf3856ad364e35_10.0.19041.1_none_00dcb92488d1132a
amd64_microsoft.windows.r..eattestation.client_31bf3856ad364e35_10.0.19041.1_none_4b9f20ed8ba53d2a
msil_microsoft.virtualiz...settings.resources_31bf3856ad364e35_10.0.19041.1_en-us_b76234975707a9af
msil_microsoft.virtualiz..on.client.resources_31bf3856ad364e35_10.0.19041.1_en-us_e5c83060d22ac246
msil_hyperv-ux-ui-vmimport_31bf3856ad364e35_10.0.19041.1_none_db0db48be3885975
msil_microsoft.virtualiz..vmbrowser.resources_31bf3856ad364e35_10.0.19041.1_en-us_13c4c81500afc6b5
amd64_dual_wsynth3dvsp.inf_31bf3856ad364e35_10.0.19041.1_none_752ccccf39042936
msil_microsoft.virtualiz..on.client.vmbrowser_31bf3856ad364e35_10.0.19041.1_none_cba1731d774de824
msil_microsoft.virtualiz..anagement.resources_31bf3856ad364e35_10.0.19041.1_en-us_96ce1ba251c74fed
amd64_microsoft.windows.h..diagnostics.payload_31bf3856ad364e35_10.0.19041.1_none_bae171a907b92555
msil_microsoft.hyperv.powershell.resources_31bf3856ad364e35_10.0.19041.388_en-us_dc185f8f79b9bb03
amd64_microsoft-hyper-v-i..ationcomponents-rdv_31bf3856ad364e35_10.0.19041.546_none_1f924896d1203578
msil_microsoft.virtualiz...client.6.3.wizards_31bf3856ad364e35_10.0.19041.1_none_b5720697df686342
amd64_vmconnect.resources_31bf3856ad364e35_10.0.19041.1_en-us_089e3810e541c02c
amd64_microsoft.windows.r..n.client.powershell_31bf3856ad364e35_10.0.19041.1_none_a71c30bf486844b3
amd64_hyperv-vmicvdev_31bf3856ad364e35_10.0.19041.546_none_ae75408cd4139857
msil_microsoft.virtualization.client.6.2_31bf3856ad364e35_10.0.19041.1_none_6dcd07baa352d291
amd64_hyperv-vmemulateddevices_31bf3856ad364e35_10.0.19041.488_none_8a151f2a721f3ff1
amd64_microsoft.windows.h..s.payload.resources_31bf3856ad364e35_10.0.19041.1_en-us_4931b0159a74f3a2
amd64_microsoft-hyper-v-v..nthfcvdev.resources_31bf3856ad364e35_10.0.19041.1_en-us_6ca4b4247e291981
amd64_hyperv-ux-featurestaging_31bf3856ad364e35_10.0.19041.1_none_d405b91d20cc7210
amd64_microsoft-hyper-v-vstack-vmms_31bf3856ad364e35_10.0.19041.546_none_148f4ea0bdbc0033
amd64_microsoft.windows.kpscore.resources_31bf3856ad364e35_10.0.19041.1_en-us_06f160822ee752f7
amd64_microsoft-windows-n..2provider.resources_31bf3856ad364e35_10.0.19041.1_en-gb_bfad695b98fced17
msil_hyperv-ux-ui-vmcreate_31bf3856ad364e35_10.0.19041.1_none_8d387dde0a6c6d14
msil_microsoft.virtualiz..lient.6.2.vmbrowser_31bf3856ad364e35_10.0.19041.1_none_9eeb7ab0c5997594
msil_hyperv-ux-ui-vmimport.resources_31bf3856ad364e35_10.0.19041.1_en-us_5db685cc755bd7f4
amd64_microsoft-hyper-v-m..lebrowser.resources_31bf3856ad364e35_10.0.19041.1_en-us_4373d0692dcd3a06
amd64_hyperv-vmemulatednic_31bf3856ad364e35_10.0.19041.153_none_dbf89e5e032cdd19
amd64_microsoft-hyper-v-m..t-remotefilebrowser_31bf3856ad364e35_10.0.19041.1_none_47b46fcdda46dc1d
amd64_microsoft-hyper-v-v..izationv2.resources_31bf3856ad364e35_10.0.19041.1_en-gb_7788797720472f2d
wow64_microsoft.hyperv.powershell.misc_31bf3856ad364e35_10.0.19041.1_none_273c7dca4464890a
amd64_hyperv-vmemulatednic.resources_31bf3856ad364e35_10.0.19041.1_en-us_c92d7c5d4661837c
amd64_microsoft-windows-h..rvice-client-events_31bf3856ad364e35_10.0.19041.1_none_40df0d0d1c299543
amd64_microsoft-hgattest-wmi_31bf3856ad364e35_10.0.19041.1_none_cb48ff1c9a81eac3
amd64_microsoft-windows-security-tpm-engine_31bf3856ad364e35_10.0.19041.1_none_9e905496ac9cb1da
msil_microsoft.virtualization.client.6.3_31bf3856ad364e35_10.0.19041.1_none_6dce0804a351ebe8
amd64_hyperv-vmtpm.resources_31bf3856ad364e35_10.0.19041.1_en-us_f085971d20ab298a
amd64_microsoft.windows.h..service.diagnostics_31bf3856ad364e35_10.0.19041.1_none_1285837a873e3361
amd64_hyperv-proxy-vmms_31bf3856ad364e35_10.0.19041.1_none_d7f7c81f5ce3ce59
msil_microsoft.hyperv.po..l.cmdlets.resources_31bf3856ad364e35_10.0.19041.388_en-us_3ff3863d6337003f
amd64_microsoft-hyper-v-m..-client.snapinabout_31bf3856ad364e35_10.0.19041.1_none_43a9017744e82ca8
msil_microsoft.hyperv.powershell.objects_31bf3856ad364e35_10.0.19041.1_none_bbae670cdada7f56
amd64_microsoft-hyper-v-vstack-synthfcvdev_31bf3856ad364e35_10.0.19041.1_none_f4c869717eb5b208
amd64_microsoft.windows.h..agnostics.resources_31bf3856ad364e35_10.0.19041.1_en-us_6607aec175f0f378
amd64_microsoft-hyper-v-sysprep-provider_31bf3856ad364e35_10.0.19041.488_none_111622e0239b7516
msil_microsoft.hyperv.po..l.objects.resources_31bf3856ad364e35_10.0.19041.1_en-us_808a35df148261b5
msil_microsoft.virtualiz..n.client.management_31bf3856ad364e35_10.0.19041.1_none_7b68c435e354f7c4
msil_microsoft.virtualiz..ient.6.2.management_31bf3856ad364e35_10.0.19041.1_none_1eaa150a959ca4c4
msil_microsoft.virtualiz..t.wizards.resources_31bf3856ad364e35_10.0.19041.1_en-us_0aedf135e046c5fc
msil_microsoft.virtualiz..2.wizards.resources_31bf3856ad364e35_10.0.19041.1_en-us_d340cc756dec450c
msil_microsoft.virtualiz..anagement.resources_31bf3856ad364e35_10.0.19041.1_en-us_76cd385ce9c8813c
amd64_microsoft-hgattest-catrustlet_31bf3856ad364e35_10.0.19041.1_none_13a24884d12d6915
amd64_microsoft-hyper-v-v..ck-virtualizationv2_31bf3856ad364e35_10.0.19041.1_none_25a2ff96aac272dd
amd64_vmconnect_31bf3856ad364e35_10.0.19041.1_none_462739ece97bd4ed
amd64_microsoft-hyper-v-management-clients_31bf3856ad364e35_10.0.19041.1_none_a87cce111f2d21d5
msil_microsoft.virtualiz...client.6.2.wizards_31bf3856ad364e35_10.0.19041.1_none_81808bbf748e856b
amd64_microsoft-hyper-v-m..apinabout.resources_31bf3856ad364e35_10.0.19041.1_en-us_d314f4eb3925c8b5
amd64_microsoft-hgattest-wmi.resources_31bf3856ad364e35_10.0.19041.1_en-gb_beb7d20c8c547f8d
amd64_wpcip.inf.resources_31bf3856ad364e35_10.0.19041.1_en-us_120050c86f137135
amd64_microsoft-hyper-v-vstack-debug_31bf3856ad364e35_10.0.19041.1_none_ba0c8961643f1b8b
amd64_microsoft-windows-h..owershell.resources_31bf3856ad364e35_10.0.19041.1_en-us_fb8ae951727dbad3
msil_inspectvhddialog6.3.resources_31bf3856ad364e35_10.0.19041.1_en-us_04b472984b9b8141
amd64_microsoft-hgattest-api_31bf3856ad364e35_10.0.19041.84_none_0e51998b2864a7b9
amd64_vmconnect6.3_31bf3856ad364e35_10.0.19041.1_none_5c4ad75abbc47892
msil_microsoft.virtualiz..vmbrowser.resources_31bf3856ad364e35_10.0.19041.1_en-us_f2bc6784484db880
amd64_microsoft-windows-nat-wmiv2provider_31bf3856ad364e35_10.0.19041.1_none_cf396423c0041ea1
amd64_hyperv-isolatedvm-svc-apisetschema_31bf3856ad364e35_10.0.19041.1_none_03bf3a66fa1ac730
amd64_microsoft.hyperv.powershell.misc_31bf3856ad364e35_10.0.19041.1_none_1ce7d3781003c70f
amd64_hyperv-isolatedvm-svc-extension_31bf3856ad364e35_10.0.19041.1_none_fb58b51c4e788636
amd64_microsoft-windows-h..nt-events.resources_31bf3856ad364e35_10.0.19041.1_en-us_941150fcb3c20f8e
amd64_microsoft-hyper-v-bpa.resources_31bf3856ad364e35_10.0.19041.1_en-us_168291f09487ebd5
amd64_hyperv-datastore_31bf3856ad364e35_10.0.19041.546_none_18d1c468aeafbd48
msil_inspectvhddialog.resources_31bf3856ad364e35_10.0.19041.1_en-us_cfff18f1c078b862
amd64_microsoft-hostguardianclient-service_31bf3856ad364e35_10.0.19041.1_none_7a5bb35e107a5373
amd64_hyperv-vmtpm_31bf3856ad364e35_10.0.19041.1_none_b09ab07eb6360de3
amd64_microsoft-windows-hgsclient-powershell_31bf3856ad364e35_10.0.19041.1_none_05f2f21e8ae082c2
amd64_microsoft.windows.kpsclient_31bf3856ad364e35_10.0.19041.1_none_5292b41087e14cd2
msil_inspectvhddialog6.2.resources_31bf3856ad364e35_10.0.19041.1_en-us_027e08860d444dd0
msil_microsoft.virtualiz...settings.resources_31bf3856ad364e35_10.0.19041.1_en-us_42a0f7782e9a34a0
amd64_vmconnect6.2_31bf3856ad364e35_10.0.19041.1_none_5c4aee22bbc45ef1
amd64_hyperv-vmicvdev.resources_31bf3856ad364e35_10.0.19041.1_en-us_d5e289b20acd78e8
amd64_microsoft-hyper-v-i..nents-rdv.resources_31bf3856ad364e35_10.0.19041.1_en-us_b3d1ef0d088d6955
amd64_wsynth3dvsp.inf.resources_31bf3856ad364e35_10.0.19041.1_en-us_c3f43c4f751788a5
msil_hyperv-ux-ui-vmcreate.resources_31bf3856ad364e35_10.0.19041.1_en-us_c2c4458d4ff5fb13
amd64_vmconnect6.3.resources_31bf3856ad364e35_10.0.19041.1_en-us_6e88d5c9d2645d8d
msil_microsoft.virtualization.client.settings_31bf3856ad364e35_10.0.19041.1_none_a5a5850b5fe77c2a
msil_microsoft.virtualiz..client.6.3.settings_31bf3856ad364e35_10.0.19041.1_none_e197434de4e70d01
amd64_microsoft-windows-hgsclient-wmi_31bf3856ad364e35_10.0.19041.1_none_abe1b9d4f9f05df2
msil_microsoft.virtualiz..mon.types.resources_31bf3856ad364e35_10.0.19041.1_en-us_05913ec3f7f5a190
amd64_microsoft-hostguard..ient-service-plugin_31bf3856ad364e35_10.0.19041.1_none_0e0a89147be645a1
amd64_microsoft-windows-remoteattestation-rtpm_31bf3856ad364e35_10.0.19041.1_none_c1c79268d9ac9f69
msil_inspectvhddialog6.2_31bf3856ad364e35_10.0.19041.1_none_7dc923aebe8d0c7f
msil_microsoft.virtualiz...settings.resources_31bf3856ad364e35_10.0.19041.1_en-us_4194453f00523eaf
amd64_microsoft-hyper-v-vstack-config_31bf3856ad364e35_10.0.19041.488_none_d31b0774b568c207
amd64_microsoft-hyper-v-v..rvcluster.resources_31bf3856ad364e35_10.0.19041.1_en-gb_71570953289cd4d0
amd64_hyperv-datastore.resources_31bf3856ad364e35_10.0.19041.1_en-us_86be62f074e84417
amd64_microsoft.certifica...certenroll.interop_31bf3856ad364e35_10.0.19041.1_none_02008b5d8d46e81e
amd64_microsoft-hyper-v-vstack-rdv_31bf3856ad364e35_10.0.19041.1_none_30c4d3b8c03afdd6
amd64_microsoft-hyper-v-lun-parser_31bf3856ad364e35_10.0.19041.1_none_b6d8bfc73f89cc96
amd64_microsoft.windows.r..owershell.resources_31bf3856ad364e35_10.0.19041.1_en-us_196a8368415dcde6
amd64_microsoft-hyper-v-m..t-clients.resources_31bf3856ad364e35_10.0.19041.1_en-us_a3e0d97c4c052586
msil_microsoft.hyperv.powershell_31bf3856ad364e35_10.0.19041.388_none_829556baefedb9f2
amd64_microsoft-hyper-v-bpa_31bf3856ad364e35_10.0.19041.1_none_555170071aa29c2c
wow64_microsoft.hyperv.powershell.cmdlets.misc_31bf3856ad364e35_10.0.19041.1_none_6d27406409f6104a
amd64_microsoft-hyper-v-3dvideo.resources_31bf3856ad364e35_10.0.19041.1_en-us_1a380741b2ac7b04
amd64_microsoft-hyper-v-v..failoverreplication_31bf3856ad364e35_10.0.19041.1_none_50b60ffc14c70fb2
amd64_microsoft-hyper-v-vstack-debug.resources_31bf3856ad364e35_10.0.19041.1_en-us_5ee8ada67d246bda
wow64_microsoft-windows-r..rdvgm-com-component_31bf3856ad364e35_10.0.19041.1_none_89aaebe4f12880ff
msil_microsoft.hyperv.powershell.cmdlets_31bf3856ad364e35_10.0.19041.388_none_2f655558eda5822e
amd64_microsoft-windows-r..pdate-oob-component_31bf3856ad364e35_10.0.19041.84_none_e539abe3d27f675f
msil_inspectvhddialog6.3_31bf3856ad364e35_10.0.19041.1_none_7dca23f8be8c25d6
amd64_microsoft-hyper-v-vstack-vmms.resources_31bf3856ad364e35_10.0.19041.1_en-us_fc0cba9450a52790
msil_microsoft.virtualiz..anagement.resources_31bf3856ad364e35_10.0.19041.1_en-us_b5aa2f5dd3dc44ed
amd64_hyperv-vmemulateddevices.resources_31bf3856ad364e35_10.0.19041.1_en-us_7217d1309a54e027
msil_microsoft.virtualiz..3.wizards.resources_31bf3856ad364e35_10.0.19041.1_en-us_5e7f8f56457ecffd
amd64_microsoft.windows.kpscore_31bf3856ad364e35_10.0.19041.1_none_88e479cc9398ae36
amd64_microsoft.windows.remoteattestation.core_31bf3856ad364e35_10.0.19041.329_none_182986653e2f0cff
amd64_microsoft-hyper-v-vstack-emulatedstorage_31bf3856ad364e35_10.0.19041.153_none_b946d5f9e63739e2
amd64_microsoft-hgattest-catrustlet.resources_31bf3856ad364e35_10.0.19041.1_en-us_9aaf00fcb0e69d2e
msil_microsoft.virtualization.client.common_31bf3856ad364e35_10.0.19041.1_none_3804358f03cbc292
amd64_microsoft-hyper-v-hgs_31bf3856ad364e35_10.0.19041.1_none_5d53c007157a9f0b
msil_inspectvhddialog_31bf3856ad364e35_10.0.19041.1_none_cc14df174755d4a1
amd64_microsoft-windows-h..lient-wmi.resources_31bf3856ad364e35_10.0.19041.1_en-gb_9efc484dab2534c2
msil_microsoft.virtualization.client.wizards_31bf3856ad364e35_10.0.19041.1_none_d69f6f59d1a5accf
msil_microsoft.virtualiz..lient.6.3.resources_31bf3856ad364e35_10.0.19041.1_en-us_16fb71254fd9fcc7
amd64_hyperv-vmsp.resources_31bf3856ad364e35_10.0.19041.1_en-us_bf8378d51b426eb0
amd64_microsoft.hyperv.powershell.cmdlets.misc_31bf3856ad364e35_10.0.19041.1_none_62d29611d5954e4f
amd64_hyperv-vmsp_31bf3856ad364e35_10.0.19041.1_none_39d506065bd87607
msil_microsoft.virtualization.client_31bf3856ad364e35_10.0.19041.610_none_136042c771c7413b
amd64_dual_wpcip.inf_31bf3856ad364e35_10.0.19041.488_none_9beb3b621a3b04ad
msil_hyperv-ux-ui-newtonsoftjson_31bf3856ad364e35_10.0.19041.1_none_f501448ecc10dc94
msil_microsoft.virtualiz..client.common.types_31bf3856ad364e35_10.0.19041.1_none_d24cf83ac2e62393
msil_microsoft.virtualiz..ient.6.3.management_31bf3856ad364e35_10.0.19041.1_none_529b8fe30076829b
amd64_microsoft.windows.kpsclient.resources_31bf3856ad364e35_10.0.19041.1_en-us_46aa5ee6836a19f5
amd64_microsoft-windows-r..component.resources_31bf3856ad364e35_10.0.19041.1_en-us_5071056aec7ab37d
amd64_microsoft-windows-r..rdvgm-com-component_31bf3856ad364e35_10.0.19041.1_none_7f564192bcc7bf04
amd64_microsoft-hyper-v-3dvideo_31bf3856ad364e35_10.0.19041.84_none_cd26e67941bcb3cc
"@

if ($langueLong -like "En-Gb"){
    foreach ($file in $($fileHyperV -Split "`r`n")) {
        if( ! (test-path $destFinale\WinSxS\$file ) ){
	        copy-item -r $srcIso\WinSxS\$file\ $destFinale\WinSxS\ -ea Silentlycontinue
        }else{
            "Error : $destFinale\WinSxS\$file"
        }
    }
}else{
    foreach ($file in $($fileHyperV -Split "`r`n")) {
        $DebNom = ($file -Split ".19041.")[0]
        $dirNames = resolve-path $srcIso\WinSxS\$DebNom*
        foreach ($r in $dirNames){
            if( ! (test-path $destFinale\WinSxS\$(($r -split "\\")[-1])) ){
                $r  >> "$destSave\copieWinSxsHyperv.txt"
	            copy-item -r $r\ $destFinale\WinSxS\ -ea Silentlycontinue
            }else{
                "? $(($r -split "\\")[-1])"
            }
        }
    }
}

# linux

# ajout des cat Microsoft-Windows-Lxss-*
Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Mise  jour du rpertoire ...\Windows\system32\CatRoot\{F750E6C3-38EE-11D1-85E5-00C04FC295EE}" 
$catRootSrc   = "$srcISO\system32\CatRoot\{F750E6C3-38EE-11D1-85E5-00C04FC295EE}"
$catrootFinale =  "$destFinale\system32\CatRoot\{F750E6C3-38EE-11D1-85E5-00C04FC295EE}"
$cats = gci  $catRootSrc  -Filter "*Microsoft-Windows-Lxss-*"
$cats | foreach {
    if ( !(test-path $catrootFinale\$($_.Name) )){
        copy-item $_.fullName $catrootFinale 
    }
}


Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Copie dans winsxs pour Subsystem-Linux"
$fileLinux=@"
amd64_microsoft-windows-lxcore_31bf3856ad364e35_10.0.19041.488_none_33aab0106ac4d2f9
amd64_microsoft-windows-lxss-bash.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_0b212bbb85501732
amd64_microsoft-windows-lxss-bash_31bf3856ad364e35_10.0.19041.423_none_1da742a41b53e164
amd64_microsoft-windows-lxss-manager.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_f62bb03618ded75f
amd64_microsoft-windows-lxss-manager_31bf3856ad364e35_10.0.19041.488_none_5c2e569b29ae348c
amd64_microsoft-windows-lxss-vm-mode_31bf3856ad364e35_10.0.19041.1_none_84865c9f15ba86d1
amd64_microsoft-windows-lxss-wsl.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_a457ec4ee1a3022c
amd64_microsoft-windows-lxss-wslapi_31bf3856ad364e35_10.0.19041.1_none_dba84816ea96253c
amd64_microsoft-windows-lxss-wslconfig_31bf3856ad364e35_10.0.19041.488_none_7eeccf5f03956a85
amd64_microsoft-windows-lxss-wslhost_31bf3856ad364e35_10.0.19041.423_none_9bd353acf86c637a
amd64_microsoft-windows-lxss-wsl_31bf3856ad364e35_10.0.19041.488_none_60be8a5c2dce0ea7
amd64_microsoft-windows-lxss_31bf3856ad364e35_10.0.19041.1_none_6223b8e2b8968ebf
wow64_microsoft-windows-lxss-manager_31bf3856ad364e35_10.0.19041.423_none_66bedf035de2d02e
amd64_microsoft-windows-l..wslconfig.resources_31bf3856ad364e35_10.0.19041.1_fr-fr_cd375cf6e95c10aa
amd64_microsoft-windows-p9np_31bf3856ad364e35_10.0.19041.1_none_60162120b9e13b06
amd64_microsoft-windows-p9rdr_31bf3856ad364e35_10.0.19041.1_none_167135e7c97dbb2c
wow64_microsoft-windows-p9np_31bf3856ad364e35_10.0.19041.1_none_6a6acb72ee41fd01
"@
if ($langueLong -like "Fr-Fr"){
    foreach ($file in $($fileLinux -Split "`r`n")) {
        if( ! (test-path $destFinale\WinSxS\$file ) ){
	        copy-item -r $srcIso\WinSxS\$file\ $destFinale\WinSxS\ -ea Silentlycontinue
        }else{
            "Error : $destFinale\WinSxS\$file"
        }
    }
}else{
    foreach ($file in $($fileLinux -Split "`r`n")) {
        $DebNom = ($file -Split ".19041.")[0]
        $dirNames = resolve-path $srcIso\WinSxS\$DebNom*
        foreach ($r in $dirNames){
            if( ! (test-path $destFinale\WinSxS\$(($r -split "\\")[-1])) ){
                $r  >> "$destSave\copieWinSxs.txt"
	            copy-item -r $r\ $destFinale\WinSxS\ -ea Silentlycontinue
            }else{
                "Error : $r"
            }
        }
    }
}


Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Dism /Enable-Feature /FeatureName:Microsoft-Hyper-V-Hypervisor"

# ajout Containers-DisposableClientVM : les copies prcdentes sont elles utiles si la source est correcte ? 
DISM.exe /Image:$driveDst /Enable-Feature /FeatureName:Microsoft-Hyper-V-Hypervisor /LimitAccess /Source:$srcISO /all


Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Dism /Enable-Feature /FeatureName:Containers-DisposableClientVM"

# ajout Containers-DisposableClientVM : les copies prcdentes sont elles utiles si la source est correcte ? 
DISM.exe /Image:$driveDst /Enable-Feature /FeatureName:Containers-DisposableClientVM /LimitAccess /Source:$srcISO /all


# ajout Microsoft-Windows-Subsystem-Linux
Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Dism /Enable-Feature /FeatureName:Microsoft-Windows-Subsystem-Linux"
DISM.exe /Image:$driveDst /Enable-Feature /FeatureName:Microsoft-Windows-Subsystem-Linux /LimitAccess /Source:$srcISO /all

# ajout wvid.inf
Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Dism  /add-driver /Driver:wvid"
#dism /image:f:\ /add-driver  /Driver:"F:\wvid\wvid.inf_amd64_922d11e84eb6b1f1\wvid.inf" /forceunsigned
$srcWvid = join-path $srcIso "System32\DriverStore\FileRepository\wvid.inf_amd64_922d11e84eb6b1f1"
$tmpWvid = join-path $driveDst "wvid.inf_amd64_922d11e84eb6b1f1"
if  (test-path $tmpWvid ) { remove-item $tmpWvid }
Copy-Item $srcWvid $tmpWvid -Recurse
DISM.exe /Image:$driveDst /add-driver  /Driver:$tmpWvid /forceunsigned


# ajout de fichiers absents de winpe
Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : $phase$($phase++) - Ajout de fichiers absents dans winpe"
$add_files=@"
wc_storage.dll
cmintegrator.dll
container.dll
containerdevicemanagement.dll
Win32AppSettingsProvider.dll
"@
$add_files -Split "`r`n" | %{
    copy-item $(join-path $srcIso "system32\$_" ) $(join-path $destFinale "system32\$_")
}

$add_f="ContainerSettingsProviders"
if(test-path $(join-path $srcIso "system32\$add_f" ) ){
    copy-item $(join-path $srcIso "system32\$add_f" ) $(join-path $destFinale "system32\$add_f") -Recurse
}else{
   Write-host -foreground Red  "$(get-date -Format HH:mm:ss) :  Absent : $(join-path $srcIso "system32\$add_f" )"
}

# dmontage vhd
Write-host -foreground Magenta  "$(get-date -Format HH:mm:ss) : dmontage du vhd"

disMount-VHD -Path $vhdpath



$EndTime=get-date
$nts = New-TimeSpan -Start $starttime -End $EndTime
Write-host -foreground Cyan  "$(get-date -Format HH:mm:ss) : Dure du traitement : $($nts.Hours)H $($nts.Minutes)Mn $($nts.Seconds)s"


