# but :  
#       - contrler l'information checksum d'un programme en comparant 
#         le checksum calul et le checksum inscrit dans le fichier par le linker
#       - modifier ce checksum si besoin ( param -modify true )

# pour le cheksum calcul et le cheksum lu dans le fichier du programme: 
#     il existe plusieurs API pour cela. Je prends celle que j'ai dj utilise : MapFileAndCheckSum de imagehlp.dll
#     https://msdn.microsoft.com/en-us/library/windows/desktop/ms680355(v=vs.85).aspx 

# pour la modification du cheksum  crire dans le fichier du programme :
#     la description du format PE d'un fichier reste incontournable
#     https://fr.wikipedia.org/wiki/Portable_Executable
#     https://msdn.microsoft.com/en-us/library/windows/desktop/ms680336(v=vs.85).aspx

<#
imagehlp.dll
DWORD MapFileAndCheckSum(
  _In_  PTSTR  Filename,
  _Out_ PDWORD HeaderSum,
  _Out_ PDWORD CheckSum
);
Filename [in]
    The file name of the file for which the checksum is to be computed.

HeaderSum [out]
    A pointer to a variable that receives the original checksum from the image file, or zero if there is an error.

CheckSum [out]
    A pointer to a variable that receives the computed checksum.

Note  The Unicode implementation of this function calls the ASCII implementation and as a result, the function can fail if the codepage does not support the characters in the path. For example, if you pass a non-English Unicode file path, and the default codepage is English, the unrecognized non-English wide chars are converted to "??" and the file cannot be opened (the function returns CHECKSUM_OPEN_FAILURE).
It is the caller's responsibility to place the newly computed checksum into the mapped image and update the on-disk image of the file.

Return                   code/value         Description
CHECKSUM_SUCCESS            0 
CHECKSUM_OPEN_FAILURE       1              Could not open the file.
CHECKSUM_MAP_FAILURE        2              Could not map the file.
CHECKSUM_MAPVIEW_FAILURE    3              Could not map a view of the file.
CHECKSUM_UNICODE_FAILURE    4              Could not convert the file name to Unicode.
**************************************************************************************
En-tte MZ sous MS-DOS :
typedef struct _IMAGE_DOS_HEADER {      // DOS .EXE header
    WORD   e_magic;                     // Magic number                      Offset = 0  --> 77 90 --> "MZ"	
    WORD   e_cblp;                      // Bytes on last page of file	     Offset = 2
    WORD   e_cp;                        // Pages in file					 Offset = 4
    WORD   e_crlc;                      // Relocations						 Offset = 6
    WORD   e_cparhdr;                   // Size of header in paragraphs		 Offset = 8
    WORD   e_minalloc;                  // Minimum extra paragraphs needed	 Offset = 10
    WORD   e_maxalloc;                  // Maximum extra paragraphs needed	 Offset = 12
    WORD   e_ss;                        // Initial (relative) SS value		 Offset = 14
    WORD   e_sp;                        // Initial SP value					 Offset = 16
    WORD   e_csum;                      // Checksum						     Offset = 18
    WORD   e_ip;                        // Initial IP value					 Offset = 20
    WORD   e_cs;                        // Initial (relative) CS value		 Offset = 22
    WORD   e_lfarlc;                    // File address of relocation table	 Offset = 24
    WORD   e_ovno;                      // Overlay number					 Offset = 26
    WORD   e_res[4];                    // Reserved words					 Offset = 28  ( +(4*2) )
    WORD   e_oemid;                     // OEM identifier (for e_oeminfo)	 Offset = 36
    WORD   e_oeminfo;                   // OEM information; e_oemid specific Offset = 38
    WORD   e_res2[10];                  // Reserved words					 Offset = 40  ( +(10*2) )
    LONG   e_lfanew;                    // File address of new exe header	 Offset = 60 --->>> 0100x = 256d
  } IMAGE_DOS_HEADER, *PIMAGE_DOS_HEADER;

En-Tte PE :
typedef struct _IMAGE_NT_HEADERS {
  DWORD                 Signature;						Offset = 256   ---> "PE\0\0"
  IMAGE_FILE_HEADER     FileHeader;						Offset = 256 + 4
  IMAGE_OPTIONAL_HEADER OptionalHeader;					Offset = 256 + 4 + sizeof(_IMAGE_NT_HEADERS) = 280
}IMAGE_NT_HEADERS, *PIMAGE_NT_HEADERS;
Signature  : Signature permettant d'identifier le fichier, qui doit tre gale  0x00004550, soit "PE\0\0" (\0 tant un octet nul).


FileHeader : 
typedef struct _IMAGE_FILE_HEADER {
  WORD  Machine;										Offset = 260 -->>  '64 86' = AMD64 ....
  WORD  NumberOfSections;								Offset = 262
  DWORD TimeDateStamp;  								Offset = 264    
  DWORD PointerToSymbolTable;							Offset = 268
  DWORD NumberOfSymbols;								Offset = 272
  WORD  SizeOfOptionalHeader;							Offset = 276
  WORD  Characteristics;								Offset = 278
}IMAGE_FILE_HEADER, *PIMAGE_FILE_HEADER; 

OptionalHeader :
typedef struct _IMAGE_OPTIONAL_HEADER {
  WORD                 Magic;							Offset = 280
  BYTE                 MajorLinkerVersion;
  BYTE                 MinorLinkerVersion;
  DWORD                SizeOfCode;						Offset = 284
  DWORD                SizeOfInitializedData;			Offset = 288
  DWORD                SizeOfUninitializedData;
  DWORD                AddressOfEntryPoint;
  DWORD                BaseOfCode;
  DWORD                BaseOfData;
  DWORD                ImageBase;
  DWORD                SectionAlignment;
  DWORD                FileAlignment;
  WORD                 MajorOperatingSystemVersion;
  WORD                 MinorOperatingSystemVersion;
  WORD                 MajorImageVersion;
  WORD                 MinorImageVersion;
  WORD                 MajorSubsystemVersion;
  WORD                 MinorSubsystemVersion;
  DWORD                Win32VersionValue;
  DWORD                SizeOfImage;
  DWORD                SizeOfHeaders;
  DWORD                CheckSum; 						Offset = 280 + 64 = 344
					                            >>>> 344..348 | % { "{0:x}"-f ($data[$_]) } = 1E A1 02 00 
					                            >>>> "{0:x8}" -f [System.BitConverter]::ToInt32($data, 344) = 0002a11e
  WORD                 Subsystem;
  WORD                 DllCharacteristics;
  DWORD                SizeOfStackReserve;
  DWORD                SizeOfStackCommit;
  DWORD                SizeOfHeapReserve;
  DWORD                SizeOfHeapCommit;
  DWORD                LoaderFlags;
  DWORD                NumberOfRvaAndSizes;
  IMAGE_DATA_DIRECTORY DataDirectory[IMAGE_NUMBEROF_DIRECTORY_ENTRIES];
} IMAGE_OPTIONAL_HEADER, *PIMAGE_OPTIONAL_HEADER;

(0..1| % { "{0}"-f [char]($data[$_]) }) -join '' = "MZ"
#>

param
(
    $filePath = "$env:windir\notepad.exe",
    $modify   = $false
)

$retoutApi=@{
    0 = "CHECKSUM_SUCCESS"
    1 = "CHECKSUM_OPEN_FAILURE       Could not open the file."
    2 = "CHECKSUM_MAP_FAILURE        Could not map the file."
    3 = "CHECKSUM_MAPVIEW_FAILURE    Could not map a view of the file."
    4 = "CHECKSUM_UNICODE_FAILURE    Could not convert the file name to Unicode."
}

$code = @'
// c:\Windows\Microsoft.NET\Framework\v4.0.30319\csc.exe  /target:exe   /out:C:\Users\noel\Desktop\informatique\c#\get-chksum.exe   C:\Users\noel\Desktop\informatique\c#\get-chksum.txt

using System;
using System.IO;
using System.Runtime.InteropServices;
using System.Text;

namespace ns_checksum{
	public class checksum {
		[DllImport("imagehlp.dll")]
 		public static extern int MapFileAndCheckSum(
    		StringBuilder Filename,
    		out int HeaderSum,
    		out int CheckSum);

    [StructLayout(LayoutKind.Sequential)]
    public struct UNICODE_STRING : IDisposable
    {
        public ushort Length;
        public ushort MaximumLength;
        private IntPtr buffer;

        public UNICODE_STRING(string s)
        {
          Length = (ushort)(s.Length * 2);
          MaximumLength = (ushort)(Length + 2);
          buffer = Marshal.StringToHGlobalUni(s);
        }

        public void Dispose()
        {
          Marshal.FreeHGlobal(buffer);
          buffer = IntPtr.Zero;
        }

        public override string ToString()
        {
          return Marshal.PtrToStringUni(buffer);
        }
    }

	static void Main (string[] args)
	{
		Console.WriteLine("Affichage du checksum lu dans l'en tte du programme et du checksum recalcul !");
		if (args.Length == 1){
			var usPrg = new StringBuilder(args[0]);
			Console.WriteLine("file = {0}",usPrg);

			int HeaderSum = 0;
			int CheckSum = 0;
			int ret = MapFileAndCheckSum( usPrg , out HeaderSum, out CheckSum);
			Console.WriteLine("ret =  {0}",ret);
			Console.WriteLine("HeaderSum = {0:X8}    CheckSum = {1:X8}", HeaderSum, CheckSum);
		}
	} //end Main

	} // end class
} //end namespace
'@
if (-not ("ns_checksum.checksum" -as [Type]))
{
    Add-Type  -TypeDefinition $code 
}


# 1 - utiliser les api pour lire et calculer le checksum 
[int] $HeaderSum = 0;
[int] $CheckSum  = 0;

$sbPrg = new-object  System.Text.StringBuilder(4096)
[void]$sbPrg.Append( $filePath )
$iRet = [ns_checksum.checksum]::MapFileAndCheckSum( $sbPrg, [ref] $HeaderSum, [ref] $CheckSum )

# 2 - test de lecture en PS du checksum dans le header afin de le modifier
$ArchiPrg   = "?"
$ChecksumLu = 0
if (Test-Path $filePath){ 
    $architecture =  @{0 = "Native"; 0x014c = "x86" ; 0x0200 = "Itanium" ; 0x8664 = "x64" } 

    $data = New-Object System.Byte[] 4096
    $stream = New-Object System.IO.FileStream -ArgumentList $filePath,Open,Read
    [void]$stream.Read($data,0,4096)
    $stream.Close()
    # on lit le contenu du pointeur  l'offset 60
    $PE_HEADER_ADDR = [System.BitConverter]::ToInt32($data, 60)
    $ArchiPrg = $architecture[[int]([System.BitConverter]::ToUInt16($data, $PE_HEADER_ADDR + 4))]
    $ChecksumLu=  '{0:X8}' -f $([System.BitConverter]::ToInt32($data, $PE_HEADER_ADDR + 4 + 20 + 64) )

}
# on collecte les info
$o = New-Object -TypeName PSObject -Property @{
    "Fichier"          =  $filePath
    "Architecture"     =  $ArchiPrg
    "Checksum (PS)"    =  $ChecksumLu
    "Retour API"       =  $retoutApi.item($iRet)
    "Link HeaderSum"   =  $('{0:X8}' -f $HeaderSum)
    "Real CheckSum"    =  $('{0:X8}' -f $CheckSum)
}
# on affiche
$o

if ($modify){
    Add-Type -AssemblyName System.Windows.Forms
    $r = [System.Windows.Forms.Messagebox]::Show("Voulez vous vraiment modifier le checksum?","Modification du checksum", [System.Windows.Forms.MessageBoxButtons]::YesNo, [System.Windows.Forms.MessageBoxIcon]::Question)
    if ($r -eq "Yes"){
        # on modifie le buffer
        $k = $PE_HEADER_ADDR + 4 + 20 + 64
        $byteChecksum = [System.BitConverter]::GetBytes($CheckSum)
        for($j=0; $j -lt $byteChecksum.count; $j++){
            $data[$k+$j] = $byteChecksum[$j]
        }

        # on crit
        $stream = New-Object System.IO.FileStream -ArgumentList $filePath,Open,write, none
        [void]$stream.Write($data,0,4096)
        $stream.Flush()
        $stream.Close()
    }

}